#include "AC.MQ4"

//<interface>
//< 1> air.Display.FormatCell     ( 6 ,  7 )
//< 2> air.Display.SetCell        ( 2 , 15 )
//< 3> air.Display.Buffer         ( 3 ,  1 )
//< 4> air.Display.Reset          ( 0 ,  8 )
//< 5> air.Display.Refresh        ( 0 ,  1 )
//< 6> air.Display.ClearBuffers   ( 1 ,  4 )
//< 7> air.Display.SetRowPointer  ( 1 ,  1 )
//< 8> air.Display.GetRowPointer  ( 1 ,  1 )
//< 9> air.Display.SetLastColumn  ( 1 ,  1 )
//<10>
//<11>
//<12>
//<13>
//<14>
//<15>
//<16>
//<17>
//<18>
//<19>
//<20>
//<21> air.Display.DrawPosition   ( 3 , 16 )
//<22> air.Display.DrawStopLevels ( 3 , 16 )
//<23> air.Display.DrawStopOrders ( 2 , 18 )
//<24> air.Display.DrawHorizontal ( 4 , 14 )
//<25> air.Display.DrawVertical   ( 4 , 14 )
//<26> air.Display.DrawChannel    ( 5 , 15 )
//<27>
//<28>
//<29>
//<30>
//<31>
//<32>
//<33>
//<34>
//<35>
//<36>
//<37>
//<38>
//<39>
//<40>
//</interface>


//<property>
int    avi.Display.RowPointer                               ; //< 1>
int    avi.Display.ColumnPointer                            ; //< 2>
int    avi.Display.LastColumn                               ; //< 3>
int    avi.Display.FontSize        = ac.FontSize            ; //< 4>
int    avi.Display.ColumnTab       [ ac.Rows , ac.Columns ] ; //< 5>
int    avi.Display.ColumnWidth     [ ac.Rows , ac.Columns ] ; //< 6>
int    avi.Display.ColumnIndent    [ ac.Rows , ac.Columns ] ; //< 7>
string avs.Display.Buffer          [ ac.Rows , ac.Columns ] ; //< 8>
int    avi.Display.PositionColor   = Green                  ; //< 9>
int    avi.Display.StopsColor      = Green                  ; //<10>
int    avi.Display.StopLossColor   = Red                    ; //<11>
int    avi.Display.TakeProfitColor = Green                  ; //<12>
//<13>
//<14>
//<15>
//<16>
//<17>
//<18>
//<19>
//<20>
//<21>
//<22>
//<23>
//<24>
//<25>
//<26>
//<27>
//<28>
//<29>
//<30>
//<31>
//<32>
//<33>
//<34>
//<35>
//<36>
//<37>
//<38>
//<39>
//<40>
//</property>

//<method 1>
int    air.Display.FormatCell

 (//<6>
       int    aai.FirstRow , int aai.LastRow ,   int aai.Column       ,
                                                 int aai.ColumnTab    ,
                                                 int aai.ColumnWidth  ,
                                                 int aai.ColumnIndent
){//<7>

static int i                                                          ;
for ( i = aai.FirstRow         ; i <= aai.LastRow  ; i ++ )
    { avi.Display.ColumnTab    [ i ,  aai.Column ] = aai.ColumnTab    ;
      avi.Display.ColumnWidth  [ i ,  aai.Column ] = aai.ColumnWidth  ;
      avi.Display.ColumnIndent [ i ,  aai.Column ] = aai.ColumnIndent ; }

aii.Core.Defence.2 ()                                                 ;

























}//</method 1>

//<method 2>
int    air.Display.SetCell

 (//<2>
       int    aai.Row    ,
       int    aai.Column


){//<15>

if ( aai.Column == 1 )  avi.Display.ColumnPointer = 0                                                                 ;
static int ali.Length ; ali.Length  = StringLen ( avs.Display.Buffer [ aai.Row , aai.Column ] )                       ;

if ( ali.Length > 0 )
   { static string   als.ObjectName ; als.ObjectName            = ObjectsTotal ()                                     ;
     ObjectCreate  ( als.ObjectName , OBJ_LABEL                 , 0 , 0 , 0  )                                        ;
     avi.Display.ColumnPointer      = avi.Display.ColumnPointer + avi.Display.ColumnTab    [ aai.Row , aai.Column   ] ;
     ObjectSet     ( als.ObjectName , OBJPROP_YDISTANCE         , avi.Display.FontSize     * aai.Row * ac.LineSpace ) ;
     ObjectSet     ( als.ObjectName , OBJPROP_XDISTANCE         , avi.Display.FontSize
                                  * ( avi.Display.ColumnPointer + avi.Display.ColumnIndent [ aai.Row , aai.Column   ]
                                  * ( avi.Display.ColumnWidth   [ aai.Row , aai.Column ]   - ali.Length         ) ) ) ;
     avi.Display.ColumnPointer      = avi.Display.ColumnPointer + avi.Display.ColumnWidth  [ aai.Row , aai.Column   ] ;

     ObjectSetText ( als.ObjectName , avs.Display.Buffer        [ aai.Row , aai.Column ]   
                                    , avi.Display.FontSize      , ac.FontName              , ac.FontColor           ) ; }

















}//</method 2>

//<method 3>
int    air.Display.Buffer

 (//<3>
       int    aai.Row    ,
       int    aai.Column ,
       string aas.String

){//<1>

avs.Display.Buffer [ aai.Row , aai.Column ] = aas.String ;































}//</method 3>

//<method 4>
int    air.Display.Reset

 (//<0>




){//<10>

ObjectsDeleteAll     ()                              ;

avi.Display.FontSize = avi.Display.FontSize   + 2    ;
air.Display.SetCell  ( 0 , 1 )                       ;
avi.Display.FontSize = avi.Display.FontSize   - 2    ;

static int        i ,  j                             ;
for   ( i = 1   ; i <= avi.Display.RowPointer ; i ++ )
  for ( j = 1   ; j <= avi.Display.LastColumn ; j ++ )
        air.Display.SetCell ( i , j )                ;






















}//</method 4>

//<method 5>
int    air.Display.Refresh

 (//<0>




){//<1>

WindowRedraw () ;































}//</method 5>

//<method 6>
int    air.Display.ClearBuffers

 (//<1>
       int    aai.RowPointer



){//<4>

static int  i , j                                  ;
for   ( i = aai.RowPointer ; i < ac.Rows    ; i ++ )
  for ( j = 1              ; j < ac.Columns ; j ++ )
        avs.Display.Buffer [ i , j ] = ""          ;




























}//</method 6>

//<method 7>
int    air.Display.SetRowPointer

 (//<1>
       int    aai.RowPointer



){//<1>

avi.Display.RowPointer = aai.RowPointer ;































}//</method 7>

//<method 8>
int    air.Display.GetRowPointer

 (//<1>
       int&   aai.RowPointer



){//<1>

aai.RowPointer = avi.Display.RowPointer ;































}//</method 8>

//<method 9>
int    air.Display.SetLastColumn

 (//<1>
       int    aai.LastColumn



){//<1>

avi.Display.LastColumn = aai.LastColumn ;































}//</method 9>

//<method 10>
int    air.Display.10

 (//<>




){//<>

































}//</method 10>

//<method 11>
int    air.Display.11

 (//<>




){//<>

































}//</method 11>

//<method 12>
int    air.Display.12

 (//<>




){//<>

































}//</method 12>

//<method 13>
int    air.Display.13

 (//<>




){//<>

































}//</method 13>

//<method 14>
int    air.Display.14

 (//<>




){//<>

































}//</method 14>

//<method 15>
int    air.Display.15

 (//<>




){//<>

































}//</method 15>

//<method 16>
int    air.Display.16

 (//<>




){//<>

































}//</method 16>

//<method 17>
int    air.Display.17

 (//<>




){//<>

































}//</method 17>

//<method 18>
int    air.Display.18

 (//<>




){//<>

































}//</method 18>

//<method 19>
int    air.Display.19

 (//<>




){//<>

































}//</method 19>

//<method 20>
int    air.Display.20

 (//<>




){//<>

































}//</method 20>

//<method 21>
int    air.Display.DrawPosition

 (//<3>
       double aad.Ask      ,
       double aad.Bid      ,
       double aad.Position

){//<16>

static bool alb.Flag ; if ( ! alb.Flag ) { alb.Flag = True                                             ;
  static string als.PositionTop          ; als.PositionTop   = "PT"                                    ;
  static string als.PositionLow          ; als.PositionLow   = "PB"                                    ; }

static   double ald.AveragePrice         ; ald.AveragePrice  = ( aad.Ask + aad.Bid )  / 2              ;
static   double ald.HslfPosition         ; ald.HslfPosition  = aad.Position           / 2              ;
static   double ald.Width                ; ald.Width         = aid.Core.ReadPort ( ac.ShowPosition   ) ;

if ( ald.Width > 0 )
   { ObjectCreate  ( als.PositionTop     , OBJ_HLINE , 0 , 0 , ald.AveragePrice + ald.HslfPosition   ) ;
     ObjectSet     ( als.PositionTop     , OBJPROP_COLOR     , avi.Display.PositionColor             ) ;
     ObjectSet     ( als.PositionTop     , OBJPROP_WIDTH     , ald.Width                             ) ;

     ObjectCreate  ( als.PositionLow     , OBJ_HLINE , 0 , 0 , ald.AveragePrice - ald.HslfPosition   ) ;
     ObjectSet     ( als.PositionLow     , OBJPROP_COLOR     , avi.Display.PositionColor             ) ;
     ObjectSet     ( als.PositionLow     , OBJPROP_WIDTH     , ald.Width                             ) ; }
















}//</method 21>

//<method 22>
int    air.Display.DrawStopLevels

 (//<3>
       double aad.Ask      ,
       double aad.Bid      ,
       double aad.Stop

){//<16>

static bool alb.Flag ; if ( ! alb.Flag ) { alb.Flag = True                                             ;
  static string als.StopTop              ; als.StopTop       = "ST"                                    ;
  static string als.StopLow              ; als.StopLow       = "SB"                                    ; }



static   double ald.Width                ; ald.Width         = aid.Core.ReadPort ( ac.ShowStopLevels ) ;

if ( ald.Width > 0 )
   { ObjectCreate  ( als.StopTop         , OBJ_HLINE , 0 , 0 , aad.Ask          + aad.Stop           ) ;
     ObjectSet     ( als.StopTop         , OBJPROP_COLOR     , avi.Display.StopsColor                ) ;
     ObjectSet     ( als.StopTop         , OBJPROP_WIDTH     , ald.Width                             ) ;

     ObjectCreate  ( als.StopLow         , OBJ_HLINE , 0 , 0 , aad.Bid          - aad.Stop           ) ;
     ObjectSet     ( als.StopLow         , OBJPROP_COLOR     , avi.Display.StopsColor                ) ;
     ObjectSet     ( als.StopLow         , OBJPROP_WIDTH     , ald.Width                             ) ; }
















}//</method 22>

//<method 23>
int    air.Display.DrawStopOrders

 (//<2>
       double aad.StopLoss   ,
       double aad.TakeProfit


){//<18>

static bool alb.Flag ; if ( ! alb.Flag ) { alb.Flag = True                                             ;
  static string als.StopLoss             ; als.StopLoss      = "SL"                                    ;
  static string als.TakeProfit           ; als.TakeProfit    = "TP"                                    ; }

static   double ald.Width                ; ald.Width         = aid.Core.ReadPort ( ac.ShowStopOrders ) ;

if ( ald.Width > 0 )
   { if ( aad.StopLoss   > 0 )
        { ObjectCreate  ( als.StopLoss   , OBJ_HLINE , 0 , 0 , aad.StopLoss                          ) ;
          ObjectSet     ( als.StopLoss   , OBJPROP_COLOR     , avi.Display.StopLossColor             ) ;
          ObjectSet     ( als.StopLoss   , OBJPROP_WIDTH     , ald.Width                             ) ;
          ObjectSet     ( als.StopLoss   , OBJPROP_STYLE     , STYLE_DASHDOT                         ) ; }

     if ( aad.TakeProfit > 0 )
        { ObjectCreate  ( als.TakeProfit , OBJ_HLINE , 0 , 0 , aad.TakeProfit                        ) ;
          ObjectSet     ( als.TakeProfit , OBJPROP_COLOR     , avi.Display.TakeProfitColor           ) ;
          ObjectSet     ( als.TakeProfit , OBJPROP_WIDTH     , ald.Width                             ) ;
          ObjectSet     ( als.TakeProfit , OBJPROP_STYLE     , STYLE_DASHDOT                         ) ; } }














}//</method 23>

//<method 24>
int    air.Display.DrawHorizontal

 (//<4>
       int    aai.Width ,
       double aad.Price ,
       int    aai.Color ,
       int    aai.Style = STYLE_SOLID
){//<14>

static string als.Name                   ; als.Name          = ObjectsTotal ()                         ;







if ( aai.Width > 0 )
   { ObjectCreate  ( als.Name            , OBJ_HLINE , 0 , 0 , aad.Price                             ) ;
     ObjectSet     ( als.Name            , OBJPROP_COLOR     , aai.Color                             ) ;
     ObjectSet     ( als.Name            , OBJPROP_WIDTH     , aai.Width                             ) ;

     ObjectSet     ( als.Name            , OBJPROP_STYLE     , aai.Style                             ) ; }


















}//</method 24>

//<method 25>
int    air.Display.DrawVertical

 (//<4>
       int    aai.Width ,
       int    aai.Time  ,
       int    aai.Color ,
       int    aai.Style = STYLE_SOLID
){//<14>

static string als.Name                   ; als.Name          = ObjectsTotal ()                         ;







if ( aai.Width > 0 )
   { ObjectCreate  ( als.Name            , OBJ_VLINE , 0     , aai.Time  , 0                         ) ;
     ObjectSet     ( als.Name            , OBJPROP_COLOR     , aai.Color                             ) ;
     ObjectSet     ( als.Name            , OBJPROP_WIDTH     , aai.Width                             ) ;

     ObjectSet     ( als.Name            , OBJPROP_STYLE     , aai.Style                             ) ; }


















}//</method 25>

//<method 26>
int    air.Display.DrawChannel

 (//<5>
       int    aai.Width  ,
       int    aai.Time.1 , int aai.Time.2 ,
       int    aai.Color  ,
       int    aai.Style = STYLE_SOLID
){//<15>

static string als.Name                   ; als.Name          = ObjectsTotal ()                         ;







if ( aai.Width > 0 )
   { ObjectCreate  ( als.Name            , OBJ_STDDEVCHANNEL , 0 , aai.Time.1 , 0 , aai.Time.2 , 0   ) ;
     ObjectSet     ( als.Name            , OBJPROP_COLOR     , aai.Color                             ) ;
     ObjectSet     ( als.Name            , OBJPROP_WIDTH     , aai.Width                             ) ;

     ObjectSet     ( als.Name            , OBJPROP_STYLE     , aai.Style                             ) ;
     ObjectSet     ( als.Name            , OBJPROP_RAY       , 0                                     ) ; }

















}//</method 26>

//<method 27>
int    air.Display.27

 (//<>




){//<>

































}//</method 27>

//<method 28>
int    air.Display.28

 (//<>




){//<>

































}//</method 28>

//<method 29>
int    air.Display.29

 (//<>




){//<>

































}//</method 29>

//<method 30>
int    air.Display.30

 (//<>




){//<>

































}//</method 30>

//<method 31>
int    air.Display.31

 (//<>




){//<>

































}//</method 31>

//<method 32>
int    air.Display.32

 (//<>




){//<>

































}//</method 32>

//<method 33>
int    air.Display.33

 (//<>




){//<>

































}//</method 33>

//<method 34>
int    air.Display.34

 (//<>




){//<>

































}//</method 34>

//<method 35>
int    air.Display.35

 (//<>




){//<>

































}//</method 35>

//<method 36>
int    air.Display.36

 (//<>




){//<>

































}//</method 36>

//<method 37>
int    air.Display.37

 (//<>




){//<>

































}//</method 37>

//<method 38>
int    air.Display.38

 (//<>




){//<>

































}//</method 38>

//<method 39>
int    air.Display.39

 (//<>




){//<>

































}//</method 39>

//<method 40>
int    air.Display.40

 (//<>




){//<>

































}//</method 40>

